package dareka.processor.impl;

import java.io.File;
import java.io.IOException;
import java.net.Socket;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Config;
import dareka.common.Logger;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Processor;
import dareka.processor.Resource;
import dareka.processor.StringResource;

// [nl] localtH_Ewrapper֌W̃AhX
public class LocalDirProcessor implements Processor {
    private static final String[] SUPPORTED_METHODS = new String[] { "GET" };
    private static final Pattern LOCAL_DIR_PATTERN = Pattern
    	.compile("^http://(?:www|res)\\.nicovideo\\.jp/(flvplayer\\.swf|flvplayer_wrapper\\.swf|flv_booster\\.swf|local(/?|/[-_\\w./]+|\\w+\\.\\w+))(\\?.*)?$");

    private Config config;
    
    public LocalDirProcessor(Config config) {
        this.config = config;
    }
    
	public String[] getSupportedMethods() {
		return SUPPORTED_METHODS;
	}

	public Pattern getSupportedURLAsPattern() {
		return LOCAL_DIR_PATTERN;
	}

	public String getSupportedURLAsString() {
		return null;
	}

	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		Matcher m = LOCAL_DIR_PATTERN.matcher(requestHeader.getURI());
		File file = null;
		if (m.find())
		{
			String path = m.group(1);
			if (path.equals("flvplayer.swf"))
			{
				// rc1[hȂlocalAȊO͌
				// dlύXɎbΏ(rc3)
				if (config.flvWrapper.equals("true"))
					file = new File("local", path);
				else {
					String nicoPlayer
						= requestHeader.getURI().replace("flvplayer.swf", "swf/nicoplayer.swf");
					requestHeader.setURI(nicoPlayer);
					return Resource.get(Resource.Type.URL, requestHeader.getURI());
				}
			}
			else if (path.equals("flvplayer_wrapper.swf"))
			{
				// nlŒuȂȂX[
				if (config.flvWrapper.equals("true") ||
						config.flvWrapper.startsWith("rc2"))
					file = new File("local", path);
				else
					return Resource.get(Resource.Type.URL, requestHeader.getURI());
			}
			else if (path.equals("flv_booster.swf")) {
				// booster
				file = new File("local", path);
			}
			else if (m.group(2) != null && !m.group(2).equals("")
										&& !m.group(2).equals("/"))
			{
				file = new File("local", m.group(2));
				if (m.group(2).equals("/list.js") && !file.exists())
					file = new File("local", "list.js.default");
			}
		}
		//Logger.info(file.getName());
		if (file != null && file.exists())
			return Resource.get(Resource.Type.URL, file.toURI().toString());
		else
			return StringResource.getNotFound();
	}

}
