package dareka.processor.impl;

import java.io.File;
import java.util.Comparator;
import java.util.Map;
import java.util.TreeMap;

/**
 * ID\[gAStringzŕԂB
 * 擪̎ʎq2͖Aԍ݂̂Ń\[g
 * sortDirection : false = ASC, true = DESC
 */
public class MovieIdSorter implements Comparator<Integer> {
	// static methods
	/**
	 * Map<String, File>  \[g String[] Ԃ
	 * @param map			\[g}bv
	 * @param sortDirection	false = ASC, true = DESC
	 * @return				\[gꂽID̔z
	 */
	public static String[] sort(Map<String, File> map, boolean sortDirection) {
		String list[] = new String[1];

		TreeMap<Integer, String> idTree
					= new TreeMap<Integer, String>(new MovieIdSorter(sortDirection));
		for (String k: map.keySet()) {
			try {
				idTree.put(Integer.valueOf(k.substring(2).replace("low", "")), k);
			} catch (NumberFormatException e) {
				// ignore this item
			}
		}
		return idTree.values().toArray(list);
		//return sort(map.keySet().toArray(list), sortDirection);
	}
	
	/**
	 * String[]  \[g String[] Ԃ
	 * @param idList		\[gID̔z
	 * @param sortDirection	false = ASC, true = DESC
	 * @return				\[gꂽID̔z
	 */
	public static String[] sort(String[] idList, boolean sortDirection) {
		TreeMap<Integer, String> idTree
					= new TreeMap<Integer, String>(new MovieIdSorter(sortDirection));
		for (String k: idList) {
			try {
				idTree.put(Integer.valueOf(k.substring(2).replace("low", "")), k);
			} catch (NumberFormatException e) {
				// ignore this item
			}
		}
		return idTree.values().toArray(idList);
	}

	// instance method
	private boolean sortDirection = false;
	private MovieIdSorter(boolean sortDirection) {
		this.sortDirection = sortDirection;
	}
	
	// Comparator<Integer> interface
	public int compare(Integer a, Integer b) {
		return (a == b) ? 0 : ((a < b)^sortDirection ? -1 : 1);
	}
}
