package dareka.processor.impl;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.net.URLDecoder;
import java.util.regex.Pattern;

import dareka.common.Config;
import dareka.common.Logger;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Processor;
import dareka.processor.Resource;
import dareka.processor.StringResource;

// [nl] I~gNGWord֌W
public class NGWordProcessor implements Processor {
	private static final String[] SUPPORTED_METHODS = new String[] { "GET" };
	String uri_local_ngword = "http://www.nicovideo.jp/local/ngword?";

	Config config;

	public NGWordProcessor(Config config) {
		this.config = config;
	}

	public String[] getSupportedMethods() {
		return SUPPORTED_METHODS;
	}

	public Pattern getSupportedURLAsPattern() {
		return null;
	}

	public String getSupportedURLAsString() {
		return uri_local_ngword;
	}

	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
		String ngword = requestHeader.getURI().substring(
				uri_local_ngword.length());

		ngword = URLDecoder.decode(ngword, "UTF-8").trim();
		byte[] b = ngword.getBytes("UTF-8");

		StringBuilder ngwordSetting = new StringBuilder();
		ngwordSetting.append("\r\n#").append(ngword).append("\r\n");
		for (int i = 0; i < b.length; i++)
			ngwordSetting.append(String.format("[%%%02x]", b[i]));
		ngwordSetting.append("\r\n");

		if (config.ngword != null && config.ngword.canWrite()) {
			try {
				OutputStream ostream = new FileOutputStream(config.ngword, true);
				ostream.write(new String(ngwordSetting).getBytes("MS932"));
				ostream.flush();
				ostream.close();
				Logger.info("NGWORD \"" + ngword + "\" added.");
			} catch (IOException e) {
				Logger.warning("NGWord t@CJ܂.");
			}
		}
		return StringResource.getNotFound();
	}

}
