package dareka.processor.impl;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Config;
import dareka.common.DiskFreeSpace;
import dareka.common.Logger;
import dareka.extensions.Rewriter;
import dareka.processor.HttpResponseHeader;

// [nl] watchy[W
public class ToolbarRewriter implements Rewriter {
    
    Config config;
    boolean showFreeSpace;
    public ToolbarRewriter(Config config) {
    	this.config = config;
    	showFreeSpace = config.getBoolean("showFreeSpace", false);
    }

	// Rewriter interface
    private static final Pattern NOWATCH_PATTERN
    	= Pattern.compile("^http://www\\.nicovideo\\.jp/(?!watch)");
	
	// URL̐K\
	public Pattern getRewriterSupportedURLAsPattern() {
		return NOWATCH_PATTERN;
	}
	
	public String onMatch(Matcher match, HttpResponseHeader responseHeader, String content)
			throws IOException {

		// [nl] [JFLVꗗւ̃N
		if (config.localFlv)
		{
			String freeSpace = "";
			long freeSize;
			if (showFreeSpace
					&& (freeSize = DiskFreeSpace.get(Cache.getCacheDir())) != Long.MAX_VALUE) {
				freeSpace = String.format("(%.2fGB)", freeSize / 1024.0 / 1024 / 1024);
			}
			content = content.replaceFirst(
						"history\">ŋߌ</a>",
						"$0 | <a href=\"/cache/\">LbV</a>" + freeSpace);
		}
		return content;
	}
}
